<?php

namespace DataView;

class Sammlung {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderScript() { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
    function changefilter_sammlung_ownerListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_sammlung_owner', val, cb.checked);
		  } else {
			  delete query['filter_sammlung_owner'];
		  }reloadsammlung();
        
    }

		var i88b2fdcb99830648ab62536a0d3a93c7606cd80602bbf60f7ca1c525f9b119c2timeout = null;
		function changefilter_sammlung_ownerSearchFilter(val, callback) {
			if(i88b2fdcb99830648ab62536a0d3a93c7606cd80602bbf60f7ca1c525f9b119c2timeout) clearTimeout(i88b2fdcb99830648ab62536a0d3a93c7606cd80602bbf60f7ca1c525f9b119c2timeout);

			i88b2fdcb99830648ab62536a0d3a93c7606cd80602bbf60f7ca1c525f9b119c2timeout = setTimeout(function() {
				$.getJSON(reloadsammlung({action: 'getfilter_sammlung_ownerItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_sammlung_owner_orig'] = val;
				});
			}, 300);
		}

	function getfilter_sammlung_ownerListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_sammlung_owner_orig']) ? json_encode($_GET['filter_sammlung_owner_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="88b2fdcb99830648ab62536a0d3a93c7606cd80602bbf60f7ca1c525f9b119c2" type="text">' +
			'<label class="mdl-textfield__label" for="88b2fdcb99830648ab62536a0d3a93c7606cd80602bbf60f7ca1c525f9b119c2">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_sammlung_owner', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_sammlung_owner_orig'] = '';
					delete query['filter_sammlung_owner'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadsammlung();
					
				} else {
					$('#table_sammlung').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_sammlung_ownerSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Sammlung::getfilter_sammlung_ownerItemsByStringAction(''));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_sammlung_owner_orig'] = '';
				delete query['filter_sammlung_owner'];
				reload('', items);reloadsammlung();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_sammlung_owner', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_sammlung_ownerListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									
    function changefilter_sammlung_ownerListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_sammlung_owner', val, cb.checked);
		  } else {
			  delete query['filter_sammlung_owner'];
		  }reloadsammlung();
        
    }

		var i88b2fdcb99830648ab62536a0d3a93c7606cd80602bbf60f7ca1c525f9b119c2timeout = null;
		function changefilter_sammlung_ownerSearchFilter(val, callback) {
			if(i88b2fdcb99830648ab62536a0d3a93c7606cd80602bbf60f7ca1c525f9b119c2timeout) clearTimeout(i88b2fdcb99830648ab62536a0d3a93c7606cd80602bbf60f7ca1c525f9b119c2timeout);

			i88b2fdcb99830648ab62536a0d3a93c7606cd80602bbf60f7ca1c525f9b119c2timeout = setTimeout(function() {
				$.getJSON(reloadsammlung({action: 'getfilter_sammlung_ownerItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_sammlung_owner_orig'] = val;
				});
			}, 300);
		}

	function getfilter_sammlung_ownerListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_sammlung_owner_orig']) ? json_encode($_GET['filter_sammlung_owner_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="88b2fdcb99830648ab62536a0d3a93c7606cd80602bbf60f7ca1c525f9b119c2" type="text">' +
			'<label class="mdl-textfield__label" for="88b2fdcb99830648ab62536a0d3a93c7606cd80602bbf60f7ca1c525f9b119c2">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_sammlung_owner', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_sammlung_owner_orig'] = '';
					delete query['filter_sammlung_owner'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadsammlung();
					
				} else {
					$('#table_sammlung').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_sammlung_ownerSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Sammlung::getfilter_sammlung_ownerItemsByStringAction(''));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_sammlung_owner_orig'] = '';
				delete query['filter_sammlung_owner'];
				reload('', items);reloadsammlung();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_sammlung_owner', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_sammlung_ownerListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									function updateNumbersammlung(col) {
										//var checklist = window.DataViewChecked['sammlung'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['sammlung'] && window.DataViewChecked['sammlung'][col].ranges.length > 0) {
											$('.sammlung__mass-action').css('visibility', 'visible');
											$('.sammlung__action').css('visibility', 'hidden');
										} else {
											$('.sammlung__mass-action').css('visibility', 'hidden');
											$('.sammlung__action').css('visibility', 'visible');
										}
										$('.sammlung__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('sammlung__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('sammlung__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadsammlung (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/Sammlung/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if ((!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/Sammlung/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#sammlung-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#sammlung-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#sammlung-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumbersammlung('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#sammlung-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadsammlung()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checksammlung (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['sammlung']) window.DataViewChecked['sammlung'] = {};
										if (!window.DataViewChecked['sammlung'][col]) window.DataViewChecked['sammlung'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['sammlung'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadsammlung({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['sammlung'][col] = new IDList(ids);
													updateNumbersammlung(col);
												});
											} else {
												window.DataViewChecked['sammlung'][col] = new IDList();
												updateNumbersammlung(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#sammlung__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['sammlung'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['sammlung'][col].push(id);
												} else {
													window.DataViewChecked['sammlung'][col].remove(id);
												}
											}
											updateNumbersammlung(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadsammlung();
			
		}

	</script>
	<?php
	
    
  }

  public static function renderTabTableAction() { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if(((\FOP\User::getSammlung()))) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="
		var self = this;
		event.preventDefault();
		$.get(reloadsammlung({action: 'open', fop_table: 'sammlung', fop_id: '_', fop_from: location.href}, true))
		.then(function () {
			window.open_url(self.href, false);
		});" href="<?php echo htmlentities(\TablesRouter\Sammlung::createURL2(['from' => $_GET['from'] ?? null, 'popup' => $_GET['popup'] ?? null])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), _('Geld-Sammlung'))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_sammlung']) ? intval($_GET['page_sammlung']) : 0);
								$addlines = (isset($_GET['addlines_sammlung']) ? intval($_GET['addlines_sammlung']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'name',
												'desc' => _('Bezeichnung'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['name'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'date',
												'desc' => _('zu bezahlen bis zum'),
												'order' => ++$order,
												'width' => 100, // default value
												'collapsed' => 0

											];
											$columns['date'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'amount',
												'desc' => _('Eingesammelter Betrag je Mitglied'),
												'order' => ++$order,
												'width' => 120, // default value
												'collapsed' => 0

											];
											$columns['amount'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'owner',
												'desc' => _('Verantwortlich'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['owner'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('sammlung'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='name'
												data-order='<?php echo intval($columns['name']['order']); ?>'
												data-width='<?php echo intval($columns['name']['width']); ?>'
												data-collapsed='<?php echo intval($columns['name']['collapsed']); ?>'
												style='width: <?php echo intval($columns['name']['width']); ?>px; <?php if ($columns['name']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadsammlung(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_sammlung_name'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_sammlung_name'] = text.val(); } else { delete query['search_sammlung_name']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_sammlung').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_sammlung_name'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_sammlung_name'] = text2.val(); } else { delete query['searchnot_sammlung_name']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_sammlung').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_sammlung'] == 'name ASC') {
			query['sort_sammlung'] = 'name DESC';
		 } else if (query['sort_sammlung'] == 'name DESC') {
		 	delete query['sort_sammlung'];
		 } else {
			query['sort_sammlung'] = 'name ASC';
		 }
		 reloadsammlung();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Bezeichnung')); ?>'><?php echo(_('Bezeichnung')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_sammlung']) && $_GET['sort_sammlung'] == 'name ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_sammlung']) && $_GET['sort_sammlung'] == 'name DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_sammlung_name']) || isset($_GET['range_max_sammlung_name']) || isset($_GET['deps_sammlung_name']) || isset($_GET['fullsearch_sammlung_name']) || isset($_GET['dynamic_sammlung_name']) || isset($_GET['search_sammlung_name']) || isset($_GET['searchnot_sammlung_name']) || isset($_GET['filter_sammlung_name'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['name']['header'] = ob_get_contents(); ob_end_clean();
											$columns['name']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['name']['width']); ?>px; <?php if ($columns['name']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='name'><span class='overflow-text' title="<?php echo htmlentities($item['name']); ?>"><?php echo htmlentities($item['name']); ?></span></div><?php
											};
											$columns['name']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='name'
													data-order='<?php echo intval($columns['name']['order']); ?>'
													data-width='<?php echo intval($columns['name']['width']); ?>'
													data-collapsed='<?php echo intval($columns['name']['collapsed']); ?>'
													style='width: <?php echo intval($columns['name']['width']); ?>px; <?php if ($columns['name']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='date'
												data-order='<?php echo intval($columns['date']['order']); ?>'
												data-width='<?php echo intval($columns['date']['width']); ?>'
												data-collapsed='<?php echo intval($columns['date']['collapsed']); ?>'
												style='width: <?php echo intval($columns['date']['width']); ?>px; <?php if ($columns['date']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadsammlung(); 
		}}, 600);
		date_filter(win, 'sammlung', 'date', <?php echo htmlentities(json_encode(_('period'))); ?>, <?php echo htmlentities(json_encode(\FOP\I18n::getShortLocale())); ?>, <?php echo htmlentities(json_encode(_('dateformat_moment'))); ?>, function() { reloadsammlung();  reloadsammlung(); });
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_sammlung'] == 'date ASC') {
			query['sort_sammlung'] = 'date DESC';
		 } else if (query['sort_sammlung'] == 'date DESC') {
		 	delete query['sort_sammlung'];
		 } else {
			query['sort_sammlung'] = 'date ASC';
		 }
		 reloadsammlung();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('zu bezahlen bis zum')); ?>'><?php echo(_('zu bezahlen bis zum')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_sammlung']) && $_GET['sort_sammlung'] == 'date ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_sammlung']) && $_GET['sort_sammlung'] == 'date DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_sammlung_date']) || isset($_GET['range_max_sammlung_date']) || isset($_GET['deps_sammlung_date']) || isset($_GET['fullsearch_sammlung_date']) || isset($_GET['dynamic_sammlung_date']) || isset($_GET['search_sammlung_date']) || isset($_GET['searchnot_sammlung_date']) || isset($_GET['filter_sammlung_date'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['date']['header'] = ob_get_contents(); ob_end_clean();
											$columns['date']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['date']['width']); ?>px; <?php if ($columns['date']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='date'><span class='overflow-text' title="<?php echo htmlentities(($item['date']) ? strftime(_('dateformat_php2'), intval($item['date'])) : ''); ?>"><?php echo htmlentities(($item['date']) ? strftime(_('dateformat_php2'), intval($item['date'])) : ''); ?></span></div><?php
											};
											$columns['date']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='date'
													data-order='<?php echo intval($columns['date']['order']); ?>'
													data-width='<?php echo intval($columns['date']['width']); ?>'
													data-collapsed='<?php echo intval($columns['date']['collapsed']); ?>'
													style='width: <?php echo intval($columns['date']['width']); ?>px; <?php if ($columns['date']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='amount'
												data-order='<?php echo intval($columns['amount']['order']); ?>'
												data-width='<?php echo intval($columns['amount']['width']); ?>'
												data-collapsed='<?php echo intval($columns['amount']['collapsed']); ?>'
												style='width: <?php echo intval($columns['amount']['width']); ?>px; <?php if ($columns['amount']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadsammlung(); 
		}});
		var von, bis; win.append('<div class=\'fop-floatsorter\'>' + window.i18n_von + '</div>').append(von = $('<input type=\'number\' step=\'any\'><br>').val(query['range_min_sammlung_amount']).on('change keyup paste', function () { query['range_min_sammlung_amount'] = von.val(); delete query['page_sammlung']; changed = true; }))
.append('<div>' + window.i18n_bis + '</div>').append(bis = $('<input type=\'number\' step=\'any\'>').val(query['range_max_sammlung_amount']).on('change keyup paste', function () { query['range_max_sammlung_amount'] = bis.val(); delete query['page_sammlung']; changed = true; }))
; von.focus(); von.select();
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_sammlung'] == 'amount ASC') {
			query['sort_sammlung'] = 'amount DESC';
		 } else if (query['sort_sammlung'] == 'amount DESC') {
		 	delete query['sort_sammlung'];
		 } else {
			query['sort_sammlung'] = 'amount ASC';
		 }
		 reloadsammlung();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	" style='text-align: right;'>
													<span class='title-title' title='<?php echo(_('Eingesammelter Betrag je Mitglied')); ?>'><?php echo(_('Eingesammelter Betrag je Mitglied')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_sammlung']) && $_GET['sort_sammlung'] == 'amount ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_sammlung']) && $_GET['sort_sammlung'] == 'amount DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_sammlung_amount']) || isset($_GET['range_max_sammlung_amount']) || isset($_GET['deps_sammlung_amount']) || isset($_GET['fullsearch_sammlung_amount']) || isset($_GET['dynamic_sammlung_amount']) || isset($_GET['search_sammlung_amount']) || isset($_GET['searchnot_sammlung_amount']) || isset($_GET['filter_sammlung_amount'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['amount']['header'] = ob_get_contents(); ob_end_clean();
											$columns['amount']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['amount']['width']); ?>px; <?php if ($columns['amount']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='amount'><span style="white-space: nowrap; width: 100%; display: inline-block; text-align: right;"><?php echo htmlentities(\Types\Euro::print($item['amount'])); ?><?php echo '&nbsp;' .  htmlentities('€'); ?>
	</span></div><?php
											};
											$columns['amount']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='amount'
													data-order='<?php echo intval($columns['amount']['order']); ?>'
													data-width='<?php echo intval($columns['amount']['width']); ?>'
													data-collapsed='<?php echo intval($columns['amount']['collapsed']); ?>'
													style='width: <?php echo intval($columns['amount']['width']); ?>px; <?php if ($columns['amount']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='owner'
												data-order='<?php echo intval($columns['owner']['order']); ?>'
												data-width='<?php echo intval($columns['owner']['width']); ?>'
												data-collapsed='<?php echo intval($columns['owner']['collapsed']); ?>'
												style='width: <?php echo intval($columns['owner']['width']); ?>px; <?php if ($columns['owner']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadsammlung(); 
		}});
		
		win.append(getfilter_sammlung_ownerListMultiFilter()); win.find('input').first().focus();
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_sammlung'] == 'owner ASC') {
			query['sort_sammlung'] = 'owner DESC';
		 } else if (query['sort_sammlung'] == 'owner DESC') {
		 	delete query['sort_sammlung'];
		 } else {
			query['sort_sammlung'] = 'owner ASC';
		 }
		 reloadsammlung();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Verantwortlich')); ?>'><?php echo(_('Verantwortlich')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_sammlung']) && $_GET['sort_sammlung'] == 'owner ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_sammlung']) && $_GET['sort_sammlung'] == 'owner DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_sammlung_owner']) || isset($_GET['range_max_sammlung_owner']) || isset($_GET['deps_sammlung_owner']) || isset($_GET['fullsearch_sammlung_owner']) || isset($_GET['dynamic_sammlung_owner']) || isset($_GET['search_sammlung_owner']) || isset($_GET['searchnot_sammlung_owner']) || isset($_GET['filter_sammlung_owner'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['owner']['header'] = ob_get_contents(); ob_end_clean();
											$columns['owner']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['owner']['width']); ?>px; <?php if ($columns['owner']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='owner'><?php
	
	call_user_func(function () use ($item) {
	$id = $item['owner'];
	$val = $item['owner::description'];
	$canView = $item['owner::canView'];
	if ($val !== null) {
		if ($canView) echo "<a tabindex=\"-1\" class=\"mdl-button mdl-button-small tbl-link\" data-tbl=\"mitglied\" data-id=\"".htmlentities($id)."\" onclick=\"event.stopPropagation(); event.preventDefault(); open_url(this.href, true);\" href=\"" . \TablesRouter\Mitglied::viewURL($id, ['from' => \FOP\Util::getBackURL()]) . "\">(…)</a>";echo htmlentities($val);
	} else {
		echo htmlentities(_('niemand') ?: '-');
	}
	});
	
?>
</div><?php
											};
											$columns['owner']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='owner'
													data-order='<?php echo intval($columns['owner']['order']); ?>'
													data-width='<?php echo intval($columns['owner']['width']); ?>'
													data-collapsed='<?php echo intval($columns['owner']['collapsed']); ?>'
													style='width: <?php echo intval($columns['owner']['width']); ?>px; <?php if ($columns['owner']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#sammlung-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#sammlung-table .fop-table-header .fop-table-column .title,
										#sammlung-table .fop-column-handle,
										#sammlung-table .fop-table-row,
										#sammlung-table .fop-table-row .fop-table-column,
										#sammlung-table .fop-table-column-multicontrol,
										#sammlung-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="sammlung">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="sammlung__all-checkbox">
														<input class="mdl-checkbox__input" id="sammlung__all-checkbox" type="checkbox" onchange="checksammlung('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon sammlung__mass-action" style='visibility: hidden;' onclick="$.get('DataView/Sammlung/permissions?id=' + checksammlung(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_sammlung_') == 0 || key.indexOf('range_max_sammlung_') == 0 || key.indexOf('deps_sammlung_') == 0 || key.indexOf('fullsearch_sammlung_') == 0 || key.indexOf('dynamic_sammlung_') == 0 || key.indexOf('search_sammlung_') == 0 || key.indexOf('searchnot_sammlung_') == 0 || key.indexOf('filter_sammlung_') == 0) delete query[key]; reloadsammlung(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_sammlung_ID'] = checksammlung(null, 'ID'); delete query['page_sammlung']; reloadsammlung(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checksammlung(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checksammlung(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && ((\FOP\User::getSammlung()))) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/Sammlung/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checksammlung(null, 'ID'))).then(function () { reloadsammlung(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('sammlung', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'sammlung', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_sammlung" <?php \EasyEditor\Navigation::printScroll('dv.Sammlung', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_sammlung\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_sammlung\'] = wantedPage;
														reloadsammlung(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style="" data-sammlung-id="<?php echo htmlentities($item['ID']); ?>"<?php if (isset($item['ID'])){
														if (isset($_GET['select']) && isset($_GET['from'])) {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) window.location.href=' . htmlentities(json_encode($_GET['from'] . '&colvalue=' . urlencode($item['ID']))) . ';" ';
														} else {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) open_url(reloadsammlung({action: \'open\', fop_table: \'sammlung\', fop_id: ' .  htmlentities(json_encode($item['ID'])) . ', fop_from: location.href}, true), false);"';
														}
													}?> >

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox sammlung__checkbox sammlung__checkbox sammlung__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="sammlung__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="sammlung__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checksammlung(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><button type="button" class="mdl-button mdl-js-button mdl-button--icon sammlung__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-sammlung-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="view" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Sammlung::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick=" if (!event.ctrlKey) { open_url(reloadsammlung({action: 'open', fop_table: 'sammlung', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; } $(this).closest('.overlay').click(); return false;  
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">find_in_page</i></span><span class="fop-menu-caption" title="<?php echo(_('open')); ?>"><?php echo(_('open')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Sammlung::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && ((\FOP\User::getSammlung()) && (\FOP\User::getSammlung())) && $item['operation::6a18d495beabc5cde32a3986559d8e0c3bb57df943e9218264f24cc4697df093'] && $item['operation::ZGkQqulb'] && (!\FOP\User::getIsGuest())) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="create_sammlungMitglied_sammlung" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\SammlungMitglied::createURL2(['column_sammlung' => $item['ID'], 'from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">create</i></span><span class="fop-menu-caption" title="<?php echo(sprintf(_('create %s'), _('Sammlungs-Mitglied'))); ?>"><?php echo(sprintf(_('create %s'), _('Sammlungs-Mitglied'))); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/Sammlung/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadsammlung(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="sammlung" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\Sammlung::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadsammlung();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?><?php
		if(isset($item['ID']) && $item['operation::view']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="sammlung" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="view" href="<?php echo htmlentities(\TablesRouter\Sammlung::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();  if (!event.ctrlKey) { open_url(reloadsammlung({action: 'open', fop_table: 'sammlung', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; }  reloadsammlung();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('open')); ?>">
				<i class="material-icons">find_in_page</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												</div><?php
												
	
    
  }

  public static function getidsAction($col) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE (('.\FOP\Database::quote(\FOP\User::getSammlung()).')) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('sammlung').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function getSQL($params) { 
    
    
    // --- BLOCK: dependency-sammlung ---
    
		if (isset($params['select']) && $params['select'] == 'sammlung') {
			$deps = [];
		}
	
    // --- BLOCK: dependency-sammlungNull ---
    
		if (isset($params['select']) && $params['select'] == 'sammlungNull') {
			$deps = [];
		}
	
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* amount */ '.qi('amount').' AS '.qi('amount').',
									/* date */ '.qi('date').' AS '.qi('date').',
									/* name */ '.qi('name').' AS '.qi('name').',
									/* operation::6a18d495beabc5cde32a3986559d8e0c3bb57df943e9218264f24cc4697df093 */ '.\FOP\Database::quote(\FOP\User::getSammlung()).' AS '.qi('operation::6a18d495beabc5cde32a3986559d8e0c3bb57df943e9218264f24cc4697df093').',
									/* operation::ZGkQqulb */ ('.\FOP\Database::quote(\FOP\User::getSammlung()).') AS '.qi('operation::ZGkQqulb').',
									/* operation::create */ ('.\FOP\Database::quote(\FOP\User::getSammlung()).') AS '.qi('operation::create').',
									/* operation::delete */ ('.\FOP\Database::quote(\FOP\User::getSammlung()).') AS '.qi('operation::delete').',
									/* operation::edit */ ('.\FOP\Database::quote(\FOP\User::getSammlung()).') AS '.qi('operation::edit').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ (CASE WHEN '.\FOP\Database::quote(\FOP\User::getAdmin()).' THEN TRUE ELSE NOT (('.qi('sammlung').'.'.qi('owner').') <> ('.\FOP\Database::sessionVarSQL('user').')) END) AS '.qi('operation::view').',
									/* owner */ '.qi('owner').' AS '.qi('owner').',
									/* owner::canView */ '.qi('ref:owner').'.'.qi('owner:canView').' AS '.qi('owner::canView').',
									/* owner::description */ '.qi('ref:owner').'.'.qi('owner:description').' AS '.qi('owner::description').',
									1
								FROM '.qi('sammlung').' '.qi('sammlung').'
								LEFT JOIN (SELECT '.qi('ID').' AS '.qi('owner:ID').', CONCAT('.qi('mitglied').'.'.qi('vorname').', \' \', '.qi('mitglied').'.'.qi('name').') AS '.qi('owner:description').', ((CASE WHEN '.\FOP\Database::quote(\FOP\User::getGruppe()).' THEN TRUE ELSE NOT (('.qi('mitglied').'.'.qi('ID').') <> ('.\FOP\Database::sessionVarSQL('user').')) END) AND (CASE WHEN '.\FOP\Database::quote(\FOP\User::getMitglied()).' THEN TRUE ELSE NOT ((('.qi('mitglied').'.'.qi('ID').') <> ('.\FOP\Database::sessionVarSQL('user').')) AND (NOT (EXISTS (SELECT (TRUE) FROM '.qi('gruppeItem').' '.qi('7sncgH3z').' WHERE '.qi('7sncgH3z').'.'.qi('item').' = '.qi('mitglied').'.'.qi('ID').' AND (EXISTS (SELECT (TRUE) FROM '.qi('gruppeVerantwortlich').' '.qi('eHueOsQC').' WHERE '.qi('eHueOsQC').'.'.qi('gruppe').' = '.qi('7sncgH3z').'.'.qi('list').' AND (('.qi('eHueOsQC').'.'.qi('mitglied').') = ('.\FOP\Database::sessionVarSQL('user').')) LIMIT 1)) LIMIT 1)))) END) AND (CASE WHEN '.\FOP\Database::quote(\FOP\User::getSuperadmin()).' THEN TRUE ELSE NOT ('.qi('mitglied').'.'.qi('superadmin').') END)) AS '.qi('owner:canView').' FROM '.qi('mitglied').') '.qi('ref:owner').' ON '.qi('ref:owner').'.'.qi('owner:ID').' = '.qi('owner').'
								WHERE (((CASE WHEN '.\FOP\Database::quote(\FOP\User::getAdmin()).' THEN TRUE ELSE NOT (('.qi('sammlung').'.'.qi('owner').') <> ('.\FOP\Database::sessionVarSQL('user').')) END)))
									AND (' . (isset($_GET['select']) && $_GET['select'] == 'sammlung' ? 'TRUE' : 'TRUE') . ')
									AND (' . (isset($_GET['select']) && $_GET['select'] == 'sammlungNull' ? 'TRUE' : 'TRUE') . ')) AS t
								LEFT JOIN '.qi('mitglied').' AS '.qi('sorter-owner').' ON t.'.qi('owner').' = '.qi('sorter-owner').'.'.qi('ID').'
								WHERE ' . (isset($params['range_min_sammlung_amount']) ? ($params['range_min_sammlung_amount'] !== '' && is_numeric($params['range_min_sammlung_amount']) ? 't.'.qi('amount').' >= ' . \FOP\Database::quote($params['range_min_sammlung_amount']) . ' AND ' : '') : '') . 
								(isset($params['range_min_sammlung_date']) ? ($params['range_min_sammlung_date'] !== '' && is_numeric($params['range_min_sammlung_date']) ? 't.'.qi('date').' >= ' . \FOP\Database::quote($params['range_min_sammlung_date']) . ' AND ' : '') : '') . 
								(isset($params['range_max_sammlung_amount']) ? ($params['range_max_sammlung_amount'] !== '' && is_numeric($params['range_max_sammlung_amount']) ? 't.'.qi('amount').' <= ' . \FOP\Database::quote($params['range_max_sammlung_amount']) . ' AND ' : '') : '') . 
								(isset($params['range_max_sammlung_date']) ? ($params['range_max_sammlung_date'] !== '' && is_numeric($params['range_max_sammlung_date']) ? 't.'.qi('date').' <= ' . \FOP\Database::quote($params['range_max_sammlung_date']) . ' AND ' : '') : '') . 
								(isset($params['filter_sammlung_name']) ? ($params['filter_sammlung_name'] !== '' ? ('(' . (new \FOP\IDList($params['filter_sammlung_name']))->toSQL('t.'.qi('name').'') . ') AND ') : '') : '') . 
								(isset($params['filter_sammlung_date']) ? ($params['filter_sammlung_date'] !== '' ? ('(' . (new \FOP\IDList($params['filter_sammlung_date']))->toSQL('t.'.qi('date').'') . ') AND ') : '') : '') . 
								(isset($params['filter_sammlung_amount']) ? ($params['filter_sammlung_amount'] !== '' ? ('(' . (new \FOP\IDList($params['filter_sammlung_amount']))->toSQL('t.'.qi('amount').'') . ') AND ') : '') : '') . 
								(isset($params['filter_sammlung_owner']) ? ($params['filter_sammlung_owner'] !== '' ? ('(' . (new \FOP\IDList($params['filter_sammlung_owner']))->toSQL('t.'.qi('owner').'') . ') AND ') : '') : '') . 
								(isset($params['filter_sammlung_ID']) ? ($params['filter_sammlung_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_sammlung_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								(isset($params['search_sammlung_name']) ? 't.'.qi('name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_sammlung_name'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_sammlung_name']) ? 'NOT t.'.qi('name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_sammlung_name'] . '%') . ' AND ' : '') . 
								(isset($params['search_sammlung']) ? '(' . 't.'.qi('name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_sammlung'] . '%') . ') AND ' : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getfilter_sammlung_ownerItemsByStringAction($fstr) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		// Auf aktive DataView-Items einschränken
		$params = $_GET;
		unset($params['filter_sammlung_owner']);
		return \Types\MitgliedNull::getItems(null, -1, $fstr, ''.qi('ID').' IN (SELECT DISTINCT t.'.qi('owner').''.self::getSQL($params).')');
	

    
  }

  public static function getData($sqladdon, $params, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params);

								$order = (\FOP\Util::array_value(array(
									'owner ASC' => 'ORDER BY '.qi('sorter-owner').'.'.qi('name').' , '.qi('sorter-owner').'.'.qi('vorname').' ',
									'owner DESC' => 'ORDER BY '.qi('sorter-owner').'.'.qi('name').' DESC, '.qi('sorter-owner').'.'.qi('vorname').' DESC',
									'name ASC' => 'ORDER BY t.'.qi('name').' ASC',
									'amount ASC' => 'ORDER BY t.'.qi('amount').' ASC',
									'date ASC' => 'ORDER BY t.'.qi('date').' ASC',
									'name DESC' => 'ORDER BY t.'.qi('name').' DESC',
									'amount DESC' => 'ORDER BY t.'.qi('amount').' DESC',
									'date DESC' => 'ORDER BY t.'.qi('date').' DESC',
									'' => ''), isset($params['sort_sammlung']) ? $params['sort_sammlung'] : '') ?: 'ORDER BY '.qi('t').'.'.qi('date').' DESC');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['date'] = intval($item['date']);
											$item['amount'] = \Types\Euro::unpack($item['amount']);
											$item['owner'] = \FOP\Sanitizers::null_converter($item['owner']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['date'] = intval($item['date']);
										$item['amount'] = \Types\Euro::unpack($item['amount']);
										$item['owner'] = \FOP\Sanitizers::null_converter($item['owner']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		
	if (isset($params['range_min_sammlung_amount']) && isset($params['range_max_sammlung_amount'])) {
		array_push($filters, _('Eingesammelter Betrag je Mitglied') . ': ' . (\Types\Euro::print($params['range_min_sammlung_amount']) .  ' €'
	) . ' ' . _('filters_between') . ' ' . (\Types\Euro::print($params['range_max_sammlung_amount']) .  ' €'
	));
	} else if (isset($params['range_min_sammlung_amount'])) {
		array_push($filters, _('Eingesammelter Betrag je Mitglied') . ': ' . _('filters_from') . ' ' . (\Types\Euro::print($params['range_min_sammlung_amount']) .  ' €'
	));
	} else if (isset($params['range_max_sammlung_amount'])) {
		array_push($filters, _('Eingesammelter Betrag je Mitglied') . ': ' . _('filters_to') . ' ' . (\Types\Euro::print($params['range_max_sammlung_amount']) .  ' €'
	));
	}
	
	if ( // Corner Case: Monat
		isset($params['range_min_sammlung_date'])
		&& isset($params['range_max_sammlung_date'])
		&& (date('d', $params['range_min_sammlung_date']) == '01') //check first day of month
		&& (date('d', $params['range_max_sammlung_date']) == date('t', $params['range_max_sammlung_date'])) //check last day of month
		&& (date('Y-m', $params['range_min_sammlung_date']) == date('Y-m', $params['range_max_sammlung_date'])) //check if same year and month
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_sammlung_date&apos;] = &apos;'.strtotime('first day of last month', $params['range_min_sammlung_date']).'&apos;;
				query[&apos;range_max_sammlung_date&apos;] = &apos;'.strtotime('last day of last month', $params['range_min_sammlung_date']).'&apos;;
				reloadsammlung(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_sammlung_date&apos;] = &apos;'.strtotime('first day of next month', $params['range_min_sammlung_date']).'&apos;;
				query[&apos;range_max_sammlung_date&apos;] = &apos;'.strtotime('last day of next month', $params['range_min_sammlung_date']).'&apos;;
				reloadsammlung(); ">add_circle_outline</i>' : ''),
			htmlentities(_('zu bezahlen bis zum') . ': ' . strftime('%B', $params['range_min_sammlung_date']) . ' ' . date('Y', $params['range_min_sammlung_date']))
		]);
	} else if ( // Corner Case: Tag
		isset($params['range_min_sammlung_date'])
		&& isset($params['range_max_sammlung_date'])
		&& (date('Y-m-d', $params['range_min_sammlung_date']) == (date('Y-m-d', $params['range_max_sammlung_date'])))
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_sammlung_date&apos;] = &apos;'.strtotime('last day', $params['range_min_sammlung_date']).'&apos;;
				query[&apos;range_max_sammlung_date&apos;] = &apos;'.strtotime('last day', $params['range_min_sammlung_date']).'&apos;;
				reloadsammlung(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_sammlung_date&apos;] = &apos;'.strtotime('next day', $params['range_min_sammlung_date']).'&apos;;
				query[&apos;range_max_sammlung_date&apos;] = &apos;'.strtotime('next day', $params['range_min_sammlung_date']).'&apos;;
				reloadsammlung(); ">add_circle_outline</i>' : ''),
			htmlentities(_('zu bezahlen bis zum') . ': ' . date('d.m.Y', $params['range_min_sammlung_date']))
		]);
	} else if ( // Corner Case: Jahr
		isset($params['range_min_sammlung_date'])
		&& isset($params['range_max_sammlung_date'])
		&& (date('Y', $params['range_min_sammlung_date']) == (date('Y', $params['range_max_sammlung_date'])))
		&& ((date('m-d', $params['range_min_sammlung_date']) == '01-01'))
		&& ((date('m-d', $params['range_max_sammlung_date']) == '12-31'))
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_sammlung_date&apos;] = &apos;'.strtotime('first day of January last year', $params['range_min_sammlung_date']).'&apos;;
				query[&apos;range_max_sammlung_date&apos;] = &apos;'.strtotime('last day of December last year', $params['range_min_sammlung_date']).'&apos;;
				reloadsammlung(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_sammlung_date&apos;] = &apos;'.strtotime('first day of January next year', $params['range_min_sammlung_date']).'&apos;;
				query[&apos;range_max_sammlung_date&apos;] = &apos;'.strtotime('last day of December next year', $params['range_min_sammlung_date']).'&apos;;
				reloadsammlung(); ">add_circle_outline</i>' : ''),
			htmlentities(_('zu bezahlen bis zum') . ': ' . date('Y', $params['range_min_sammlung_date']))
		]);
	} else if ( // Corner Case: Quartal
		isset($params['range_min_sammlung_date'])
		&& isset($params['range_max_sammlung_date'])
		&& ( (
		 ((date('m-d', $params['range_min_sammlung_date']) == '01-01'))
		&& ((date('m-d', $params['range_max_sammlung_date']) == '03-31')) )
		|| (
		 ((date('m-d', $params['range_min_sammlung_date']) == '04-01'))
		&& ((date('m-d', $params['range_max_sammlung_date']) == '06-30')) )
		|| (
		 ((date('m-d', $params['range_min_sammlung_date']) == '07-01'))
		&& ((date('m-d', $params['range_max_sammlung_date']) == '09-30')) )
		|| (
		 ((date('m-d', $params['range_min_sammlung_date']) == '10-01'))
		&& ((date('m-d', $params['range_max_sammlung_date']) == '12-31')) )
	) ) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
					query[&apos;range_min_sammlung_date&apos;] = &apos;'.strtotime('first day of -3 months', $params['range_min_sammlung_date']).'&apos;;
					query[&apos;range_max_sammlung_date&apos;] = &apos;'.strtotime('last day of -3 months', $params['range_max_sammlung_date']).'&apos;;
					reloadsammlung(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_sammlung_date&apos;] = &apos;'.strtotime('first day of +3 months', $params['range_min_sammlung_date']).'&apos;;
				query[&apos;range_max_sammlung_date&apos;] = &apos;'.strtotime('last day of +3 months', $params['range_max_sammlung_date']).'&apos;;
				reloadsammlung(); ">add_circle_outline</i>' : ''),	
			htmlentities(_('zu bezahlen bis zum') . ': Q' . (ceil((date('m', $params['range_min_sammlung_date']))/3)) . ' (' . date('d.m.', $params['range_min_sammlung_date']) . ' - ' . date('d.m.Y', $params['range_max_sammlung_date']) . ')')
		]);
	}
	else if (isset($params['range_min_sammlung_date']) && isset($params['range_max_sammlung_date'])) {
		array_push($filters, _('zu bezahlen bis zum') . ': ' . (($params['range_min_sammlung_date']) ? strftime(_('dateformat_php2'), intval($params['range_min_sammlung_date'])) : '') . ' ' . _('filters_between') . ' ' . (($params['range_max_sammlung_date']) ? strftime(_('dateformat_php2'), intval($params['range_max_sammlung_date'])) : ''));
	} else if (isset($params['range_min_sammlung_date'])) {
		array_push($filters, _('zu bezahlen bis zum') . ': ' . _('filters_from') . ' ' . (($params['range_min_sammlung_date']) ? strftime(_('dateformat_php2'), intval($params['range_min_sammlung_date'])) : ''));
	} else if (isset($params['range_max_sammlung_date'])) {
		array_push($filters, _('zu bezahlen bis zum') . ': ' . _('filters_to') . ' ' . (($params['range_max_sammlung_date']) ? strftime(_('dateformat_php2'), intval($params['range_max_sammlung_date'])) : ''));
	}if (isset($params['filter_sammlung_name'])) {
		if ($params['filter_sammlung_name'] == '_null') {
			array_push($filters, _('Bezeichnung') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_sammlung_name']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Bezeichnung') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_sammlung_date'])) {
		if ($params['filter_sammlung_date'] == '_null') {
			array_push($filters, _('zu bezahlen bis zum') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_sammlung_date']))->all() AS $val) {
				$value = ($val) ? strftime(_('dateformat_php2'), intval($val)) : '';
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('zu bezahlen bis zum') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_sammlung_amount'])) {
		if ($params['filter_sammlung_amount'] == '_null') {
			array_push($filters, _('Eingesammelter Betrag je Mitglied') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_sammlung_amount']))->all() AS $val) {
				$value = \Types\Euro::print($val) .  ' €'
	;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Eingesammelter Betrag je Mitglied') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_sammlung_owner'])) {
		if ($params['filter_sammlung_owner'] == '_null') {
			array_push($filters, _('Verantwortlich') . ': ' . _('niemand'));
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_sammlung_owner']))->all() AS $val) {
				$value = 
  \FOP\Database::query('SELECT CONCAT('.qi('mitglied').'.'.qi('vorname').', \' \', '.qi('mitglied').'.'.qi('name').') AS description FROM '.qi('mitglied').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($val))->fetchColumn() ?: _('niemand')
;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Verantwortlich') . ': ' . implode(', ', $values));
		}
	}if (isset($params['search_sammlung_name'])) {
		array_push($filters, _('name') . ' ' . _('filter_contains') . ' ' . $params['search_sammlung_name']);
	}if (isset($params['searchnot_sammlung_name'])) {
		array_push($filters, _('name') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_sammlung_name']);
	}
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_sammlung_\')) delete query[q];} reloadsammlung(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'sammlung') {
	\FOP\Session::setPayload('dv-sammlung', [
		'id' => 'sammlung',
		'tbl' => 'sammlung',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\Sammlung::stepURL('sammlung', 'XXX', -1),
		'next' => \DataViewRouter\Sammlung::stepURL('sammlung', 'XXX',  1),
		'from' => $fop_from
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\Sammlung::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



